<html>
<head>
<title>OgreShadowTextureManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreShadowTextureManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreShadowTextureManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*-------------------------------------------------------------------------</span>
<a name="l00002"></a>00002 <span class="comment">This source file is a part of OGRE</span>
<a name="l00003"></a>00003 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00009"></a>00009 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00010"></a>00010 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00011"></a>00011 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00012"></a>00012 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00013"></a>00013 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00016"></a>00016 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00019"></a>00019 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00020"></a>00020 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00021"></a>00021 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00022"></a>00022 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00023"></a>00023 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00024"></a>00024 <span class="comment">THE SOFTWARE</span>
<a name="l00025"></a>00025 <span class="comment"></span>
<a name="l00026"></a>00026 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00027"></a>00027 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00028"></a>00028 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00029"></a>00029 <span class="comment">-------------------------------------------------------------------------*/</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifndef __ShadowTextureManager_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#define __ShadowTextureManager_H__</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="comment">// Precompiler options</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgrePixelFormat_8h.html">OgrePixelFormat.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>Ogre
<a name="l00042"></a>00042 {
<a name="l00049"></a><a class="code" href="group__Scene.html#ga9befe4ef9c189ac3f2e016a63d560c67">00049</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;TexturePtr&gt;::type</a> <a class="code" href="group__Scene.html#ga9befe4ef9c189ac3f2e016a63d560c67">ShadowTextureList</a>;
<a name="l00050"></a>00050 
<a name="l00052"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html">00052</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1ShadowTextureConfig.html" title="Structure containing the configuration for one shadow texture.">ShadowTextureConfig</a>
<a name="l00053"></a>00053     {
<a name="l00054"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html#a90f0b94c8b385c5df3cd1b39fd5b0e56">00054</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a90f0b94c8b385c5df3cd1b39fd5b0e56">width</a>;
<a name="l00055"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html#a0c27fe5c351d3697932ead1893ddf16d">00055</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a0c27fe5c351d3697932ead1893ddf16d">height</a>;
<a name="l00056"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html#abeaa5079ee032be898755c74bdd6ec10">00056</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="structOgre_1_1ShadowTextureConfig.html#abeaa5079ee032be898755c74bdd6ec10">format</a>;
<a name="l00057"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html#a7babac3b47c252bb20167395eabaccad">00057</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a7babac3b47c252bb20167395eabaccad">fsaa</a>;
<a name="l00058"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html#adff6099049e80aea87663b51d7e3659b">00058</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a>      <a class="code" href="structOgre_1_1ShadowTextureConfig.html#adff6099049e80aea87663b51d7e3659b">depthBufferPoolId</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="structOgre_1_1ShadowTextureConfig.html#a1572e06277a6253f88d16891a3a8aa25">00060</a>         <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a1572e06277a6253f88d16891a3a8aa25">ShadowTextureConfig</a>()
<a name="l00061"></a>00061             : <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a90f0b94c8b385c5df3cd1b39fd5b0e56">width</a>(512), <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a0c27fe5c351d3697932ead1893ddf16d">height</a>(512), <a class="code" href="structOgre_1_1ShadowTextureConfig.html#abeaa5079ee032be898755c74bdd6ec10">format</a>(<a class="code" href="group__Image.html#gga7e0353e7d36d4c2e8468641b7303d39ca2542d39f6712cb6f69907330a31a9342" title="32-bit pixel format, 8 bits for red, 8 bits for green, 8 bits for blue like PF_A8R8G8B8, but alpha will get discarded">PF_X8R8G8B8</a>), <a class="code" href="structOgre_1_1ShadowTextureConfig.html#a7babac3b47c252bb20167395eabaccad">fsaa</a>(0), <a class="code" href="structOgre_1_1ShadowTextureConfig.html#adff6099049e80aea87663b51d7e3659b">depthBufferPoolId</a>(1) {}
<a name="l00062"></a>00062     };
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="group__Scene.html#ga0f71238039ee719563bf5202d80ff41a">00064</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;ShadowTextureConfig&gt;::type</a> <a class="code" href="group__Scene.html#ga0f71238039ee719563bf5202d80ff41a">ShadowTextureConfigList</a>;
<a name="l00065"></a><a class="code" href="group__Scene.html#ga40acba93d9441f2bccfa096b641c887d">00065</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;ShadowTextureConfigList&gt;</a> <a class="code" href="group__Scene.html#ga40acba93d9441f2bccfa096b641c887d">ConstShadowTextureConfigIterator</a>;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html" title="Structure containing the configuration for one shadow texture.">ShadowTextureConfig</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html" title="Structure containing the configuration for one shadow texture.">ShadowTextureConfig</a>&amp; rhs );
<a name="l00068"></a>00068     <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!= </a>( <span class="keyword">const</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html" title="Structure containing the configuration for one shadow texture.">ShadowTextureConfig</a>&amp; lhs, <span class="keyword">const</span> <a class="code" href="structOgre_1_1ShadowTextureConfig.html" title="Structure containing the configuration for one shadow texture.">ShadowTextureConfig</a>&amp; rhs );
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00081"></a><a class="code" href="classOgre_1_1ShadowTextureManager.html">00081</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager instances...">ShadowTextureManager</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ShadowTextureManager&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ShadowDataAlloc</a>
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keyword">protected</span>:
<a name="l00084"></a><a class="code" href="classOgre_1_1ShadowTextureManager.html#a11584745e67a2cbc658c5a11c055aeab">00084</a>         <a class="code" href="group__Scene.html#ga9befe4ef9c189ac3f2e016a63d560c67">ShadowTextureList</a> <a class="code" href="classOgre_1_1ShadowTextureManager.html#a11584745e67a2cbc658c5a11c055aeab">mTextureList</a>;
<a name="l00085"></a><a class="code" href="classOgre_1_1ShadowTextureManager.html#a443e81e5e6904d6cb7456e11dcbe0e13">00085</a>         <a class="code" href="group__Scene.html#ga9befe4ef9c189ac3f2e016a63d560c67">ShadowTextureList</a> <a class="code" href="classOgre_1_1ShadowTextureManager.html#a443e81e5e6904d6cb7456e11dcbe0e13">mNullTextureList</a>;
<a name="l00086"></a><a class="code" href="classOgre_1_1ShadowTextureManager.html#a79402f124e553579527bac05648b7547">00086</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1ShadowTextureManager.html#a79402f124e553579527bac05648b7547">mCount</a>;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     <span class="keyword">public</span>:
<a name="l00089"></a>00089         <a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager instances...">ShadowTextureManager</a>();
<a name="l00090"></a>00090         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager instances...">ShadowTextureManager</a>();
<a name="l00091"></a>00091 
<a name="l00095"></a>00095         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getShadowTextures(<span class="keyword">const</span> <a class="code" href="group__Scene.html#ga0f71238039ee719563bf5202d80ff41a">ShadowTextureConfigList</a>&amp; config, 
<a name="l00096"></a>00096             <a class="code" href="group__Scene.html#ga9befe4ef9c189ac3f2e016a63d560c67">ShadowTextureList</a>&amp; listToPopulate);
<a name="l00097"></a>00097 
<a name="l00101"></a>00101         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> getNullShadowTexture(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> format);
<a name="l00102"></a>00102 
<a name="l00108"></a>00108         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearUnused();
<a name="l00113"></a>00113         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clear();
<a name="l00114"></a>00114 
<a name="l00130"></a>00130         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager instances...">ShadowTextureManager</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00146"></a>00146         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ShadowTextureManager.html" title="Class to manage the available shadow textures which may be shared between many SceneManager instances...">ShadowTextureManager</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148     };
<a name="l00149"></a>00149 
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
